/*
 * Copyright (c) 2018-2020 C4
 *
 * This file is part of Curios, a mod made for Minecraft.
 *
 * Curios is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Curios is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Curios.  If not, see <https://www.gnu.org/licenses/>.
 */

package top.theillusivec4.curios.client;

import io.netty.buffer.Unpooled;
import net.fabricmc.api.ClientModInitializer;
import net.fabricmc.fabric.api.client.screenhandler.v1.ScreenRegistry;
import net.fabricmc.fabric.api.event.client.ClientSpriteRegistryCallback;
import net.fabricmc.fabric.api.event.client.ClientTickCallback;
import net.fabricmc.fabric.api.network.ClientSidePacketRegistry;
import net.minecraft.class_1723;
import net.minecraft.class_2540;
import net.minecraft.class_2960;
import top.theillusivec4.curios.api.CuriosApi;
import top.theillusivec4.curios.api.SlotTypePreset;
import top.theillusivec4.curios.client.render.CuriosRenderComponents;
import top.theillusivec4.curios.client.screen.CuriosScreen;
import top.theillusivec4.curios.common.CuriosRegistry;
import top.theillusivec4.curios.common.CuriosNetwork;

public class CuriosClient implements ClientModInitializer {

  @Override
  public void onInitializeClient() {
    CuriosApi.setIconHelper(new IconHelper());
    KeyRegistry.registerKeys();
    ClientTickCallback.EVENT.register(client -> {

      if (KeyRegistry.openCurios.method_1436()) {
        ClientSidePacketRegistry.INSTANCE
            .sendToServer(CuriosNetwork.OPEN_CURIOS, new class_2540(Unpooled.buffer()));
      }
    });
    ScreenRegistry.register(CuriosRegistry.CURIOS_SCREENHANDLER, CuriosScreen::new);
    ClientSpriteRegistryCallback.event(class_1723.field_21668).register(((spriteAtlasTexture, registry) -> {
      for (SlotTypePreset preset : SlotTypePreset.values()) {
        registry.register(new class_2960(CuriosApi.MODID, "item/empty_" + preset.getIdentifier() + "_slot"));
      }
      registry.register(new class_2960(CuriosApi.MODID, "item/empty_cosmetic_slot"));
      registry.register(new class_2960(CuriosApi.MODID, "item/empty_curio_slot"));
    }));
    CuriosRenderComponents.register();
    CuriosClientNetwork.registerPackets();
  }
}
