/*
 * Copyright (c) 2018-2020 C4
 *
 * This file is part of Curios, a mod made for Minecraft.
 *
 * Curios is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Curios is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Curios.  If not, see <https://www.gnu.org/licenses/>.
 */

package top.theillusivec4.curios.client.screen;

import com.mojang.blaze3d.systems.RenderSystem;
import net.minecraft.class_2960;
import net.minecraft.class_310;
import net.minecraft.class_344;
import net.minecraft.class_4185;
import net.minecraft.class_4587;
import top.theillusivec4.curios.common.inventory.CurioSlot;

public class RenderToggleButton extends class_344 {

  private final class_2960 identifier;
  private final int yTexStart;
  private final int xTexStart;
  private final CurioSlot slot;

  private boolean wasHovered = false;

  public RenderToggleButton(CurioSlot slot, int xIn, int yIn, int widthIn, int heightIn,
      int xTexStartIn, int yTexStartIn, int yDiffTextIn, class_2960 identifier,
      class_4185.class_4241 onPressIn) {
    super(xIn, yIn, widthIn, heightIn, xTexStartIn, yTexStartIn, yDiffTextIn, identifier, 256, 256,
        onPressIn);
    this.identifier = identifier;
    this.yTexStart = yTexStartIn;
    this.xTexStart = xTexStartIn;
    this.slot = slot;
  }

  @Override
  public void method_25394(class_4587 matrixStack, int mouseX, int mouseY, float delta) {

    if (this.field_22764) {
      this.field_22762 = mouseX >= this.field_22760 && mouseY >= this.field_22761 && mouseX < this.field_22760 + this.field_22758 && mouseY < this.field_22761 + this.field_22759;

      if (this.wasHovered != this.method_25367()) {

        if (this.method_25367()) {

          if (this.method_25370()) {
            this.method_25362(200);
          } else {
            this.method_25362(750);
          }
        } else {
          this.field_22766 = Long.MAX_VALUE;
        }
      }

      if (this.field_22764) {
        this.method_25359(matrixStack, mouseX, mouseY, delta);
      }
      this.method_25366();
      this.wasHovered = this.method_25367();
    }
  }

  public void renderButtonOverlay(class_4587 matrixStack, int mouseX, int mouseY,
      float partialTicks) {
    class_310 minecraft = class_310.method_1551();
    minecraft.method_1531().method_22813(this.identifier);
    RenderSystem.disableDepthTest();
    int j = this.xTexStart;

    if (!slot.getRenderStatus()) {
      j += 8;
    }
    method_25290(matrixStack, this.field_22760, this.field_22761, (float) j, (float) this.yTexStart, this.field_22758,
        this.field_22759, 256, 256);
    RenderSystem.enableDepthTest();
  }
}
