/*
 * Copyright (c) 2018-2020 C4
 *
 * This file is part of Curios, a mod made for Minecraft.
 *
 * Curios is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Curios is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Curios.  If not, see <https://www.gnu.org/licenses/>.
 */

package top.theillusivec4.curios.common;

import io.netty.buffer.Unpooled;
import net.fabricmc.fabric.api.network.ServerSidePacketRegistry;
import net.fabricmc.fabric.api.server.PlayerStream;
import net.minecraft.class_1657;
import net.minecraft.class_1703;
import net.minecraft.class_1799;
import net.minecraft.class_2371;
import net.minecraft.class_2540;
import net.minecraft.class_2960;
import top.theillusivec4.curios.api.CuriosApi;
import top.theillusivec4.curios.common.inventory.screen.CuriosScreenHandler;
import top.theillusivec4.curios.common.inventory.screen.CuriosScreenHandlerFactory;

public class CuriosNetwork {

  public static final class_2960 OPEN_CURIOS = new class_2960(CuriosApi.MODID, "open_curios");
  public static final class_2960 SCROLL = new class_2960(CuriosApi.MODID, "scroll");
  public static final class_2960 OPEN_VANILLA = new class_2960(CuriosApi.MODID, "open_vanilla");
  public static final class_2960 TOGGLE_RENDER = new class_2960(CuriosApi.MODID, "toggle_render");
  public static final class_2960 GRAB_ITEM = new class_2960(CuriosApi.MODID, "grab_item");
  public static final class_2960 SET_ICONS = new class_2960(CuriosApi.MODID, "set_icons");
  public static final class_2960 BREAK = new class_2960(CuriosApi.MODID, "break");

  public static void registerPackets() {
    CuriosApi.getCuriosHelper().setBrokenCurioConsumer((id, index, livingEntity) -> {
      class_2540 packetByteBuf = new class_2540(Unpooled.buffer());
      packetByteBuf.writeInt(livingEntity.method_5628());
      packetByteBuf.method_10814(id);
      packetByteBuf.writeInt(index);

      if (livingEntity instanceof class_1657) {
        ServerSidePacketRegistry.INSTANCE
            .sendToPlayer((class_1657) livingEntity, CuriosNetwork.BREAK, packetByteBuf);
      }
      PlayerStream.watching(livingEntity).forEach(watcher -> ServerSidePacketRegistry.INSTANCE
          .sendToPlayer(watcher, CuriosNetwork.BREAK, packetByteBuf));
    });

    ServerSidePacketRegistry.INSTANCE.register(OPEN_CURIOS,
        ((packetContext, packetByteBuf) -> packetContext.getTaskQueue().execute(() -> {
          class_1657 playerEntity = packetContext.getPlayer();

          if (playerEntity != null) {
            class_1799 stack = playerEntity.field_7514.method_7399();
            playerEntity.field_7514.method_7396(class_1799.field_8037);
            playerEntity.method_17355(new CuriosScreenHandlerFactory());

            if (!stack.method_7960()) {
              playerEntity.field_7514.method_7396(stack);
              class_2540 buf = new class_2540(Unpooled.buffer());
              buf.method_10793(stack);
              ServerSidePacketRegistry.INSTANCE.sendToPlayer(playerEntity, GRAB_ITEM, buf);
            }
          }
        })));

    ServerSidePacketRegistry.INSTANCE.register(SCROLL, (((packetContext, packetByteBuf) -> {
      int syncId = packetByteBuf.readInt();
      int lastScrollIndex = packetByteBuf.readInt();

      packetContext.getTaskQueue().execute(() -> {
        class_1657 playerEntity = packetContext.getPlayer();
        class_1703 screenHandler = playerEntity.field_7512;

        if (screenHandler instanceof CuriosScreenHandler && screenHandler.field_7763 == syncId) {
          ((CuriosScreenHandler) screenHandler).scrollToIndex(lastScrollIndex);
        }
      });
    })));

    ServerSidePacketRegistry.INSTANCE.register(TOGGLE_RENDER, (((packetContext, packetByteBuf) -> {
      int index = packetByteBuf.readInt();
      String id = packetByteBuf.method_10800(25);

      packetContext.getTaskQueue().execute(() -> {
        class_1657 playerEntity = packetContext.getPlayer();
        CuriosApi.getCuriosHelper().getCuriosHandler(playerEntity)
            .ifPresent(handler -> handler.getStacksHandler(id).ifPresent(stacksHandler -> {
              class_2371<Boolean> renderStatuses = stacksHandler.getRenders();

              if (renderStatuses.size() > index) {
                boolean value = !renderStatuses.get(index);
                renderStatuses.set(index, value);
                handler.sync();
              }
            }));
      });
    })));
  }
}
