/*
 * Copyright (c) 2018-2020 C4
 *
 * This file is part of Curios, a mod made for Minecraft.
 *
 * Curios is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Curios is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Curios.  If not, see <https://www.gnu.org/licenses/>.
 */

package top.theillusivec4.curios.mixin;

import java.util.Map;
import net.minecraft.class_1303;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1890;
import net.minecraft.class_1893;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import top.theillusivec4.curios.api.CuriosApi;
import top.theillusivec4.curios.api.type.inventory.ICurioStacksHandler;

@Mixin(class_1303.class)
public class ExperienceOrbEntityMixin {

  @Shadow
  int amount;

  @Inject(method = "onPlayerCollision", at = @At(value = "INVOKE", target = "net/minecraft/enchantment/EnchantmentHelper.chooseEquipmentWith (Lnet/minecraft/enchantment/Enchantment;Lnet/minecraft/entity/LivingEntity;Ljava/util/function/Predicate;)Ljava/util/Map$Entry;"))
  private void onPlayerCollision(class_1657 playerEntity, CallbackInfo cb) {
    @SuppressWarnings("ConstantConditions") class_1303 orb = (class_1303) (Object) this;
    CuriosApi.getCuriosHelper().getCuriosHandler(playerEntity).ifPresent(handler -> {
      Map<String, ICurioStacksHandler> curios = handler.getCurios();

      for (ICurioStacksHandler stacksHandler : curios.values()) {

        for (int i = 0; i < stacksHandler.getSlots(); i++) {
          class_1799 stack = stacksHandler.getStacks().method_5438(i);

          if (!stack.method_7960() && class_1890.method_8225(class_1893.field_9101, stack) > 0
              && stack.method_7986()) {
            playerEntity.field_7504 = 2;
            playerEntity.method_6103(orb, 1);
            int toRepair = Math.min(orb.method_5919() * 2, stack.method_7919());
            this.amount -= toRepair / 2;
            stack.method_7974(stack.method_7919() - toRepair);

            if (orb.method_5919() > 0) {
              playerEntity.method_7255(orb.method_5919());
            }
            orb.method_5650();
            cb.cancel();
            return;
          }
        }
      }
    });
  }
}
